package com.bcxin.event.repositories.configs;

import com.bcxin.event.repositories.EventSourceRepository;
import com.bcxin.event.repositories.repositories.JpaEventSourceRepository;
import com.bcxin.event.services.EventSourceService;
import com.bcxin.event.services.impls.EventSourceServiceImpl;
import com.bcxin.saas.core.components.JsonProvider;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;

@Configuration("com.bcxin.event.repositories.configs.SetupConfig")
@EnableJpaRepositories(basePackages = "com.bcxin.event.repositories.repositories")
@EntityScan(basePackages = "com.bcxin.event.entities")
public class SetupConfig {
    @Bean
    public EventSourceRepository eventSourceRepository(JpaEventSourceRepository eventSourceRepository) {
        return eventSourceRepository;
    }

    @Bean
    public EventSourceService eventSourceService(JsonProvider jsonProvider,
                                                 EventSourceRepository eventSourceRepository) {
        return new EventSourceServiceImpl(jsonProvider, eventSourceRepository);
    }
}